import * as React from 'react'
import {useCallback,useEffect, useState} from 'react'
import {jsSdk} from "../index";
import {Button, Input,Table,Tabs,Space} from "antd";
import {SearchOutlined,LeftOutlined,CloseCircleOutlined } from '@ant-design/icons';
import {selectUserBase,linkData,unlinkData} from "../api";
import creatHistory from 'history/createHashHistory'  //返回上一页这段代码

const history = creatHistory();

const {TextArea} = Input
const { TabPane } = Tabs;

const Actions: React.FC = () => {
  const [msg, setMsg] = useState<string>('')
  const [columns]=useState<any>([
    {
      title: '头像',
      dataIndex: 'avatar',
      render: (text:string, record:any) => (
        <Space size="middle">
          <img className='avatar' src={record.avatar} alt="" />
        </Space>
      ),
    },
    {
      title: '昵称',
      className: 'name',
      dataIndex:'name',
      align:'center'
    },
    {
      title: '手机号',
      dataIndex: 'phone',
      align:'center'
    },
    {
      title: '组织',
      dataIndex: 'org',
      align:'center'
    },
    {
      title: '操作',
      align:'center',
      dataIndex: 'action',
      // render: (text:string, record:any) => (
      //   <Space size="middle">
      //     {record.link?
      //     <Button type="primary" danger onClick={unlink.bind(this,record)}>取消关联</Button>:
      //     <Button type="primary" onClick={link.bind(this,record)}>关联</Button>}
      //   </Space>
      // ),
    }
  ])
  const [listQuery, setListQuery] = useState<any>(
    {
      mobileOrUserName:'',
      page:1,
      limit:10
    }
  )
  const [listData, setListData] = useState<any>([])
  const [tabs]=useState<any>(['客户档案','纷享销客','戈友好物','戈友圈'])
  // const tabIndex ='0'
  const [tabIndex,setTabindex] = useState('0')
  //事件
  //tab更改事件
  const callback = (e:any)=>{
    console.log(e,tabIndex)
    let newvalue = e
    setTabindex((tabIndex:any)=>{
      return newvalue
    })
    console.log(tabIndex)
    // this.setSate({

    // })
  }
  //关联
  const link =async (value:any,index:any)=>{
    const res = await jsSdk.invoke<{ userId?: string }>('getCurExternalContact', {})
    if (!res || !res.userId) return
    let data:any = {wxId:res.userId,userId:value.id}
    const linkdata = await linkData(data)
    if(linkdata.data==='bind OK'){
      let data = listData
      data[index].islink = true
      setListData([...data])
    }
  }
  //取消关联
  const unlink = async (value:any,index:any)=>{    
    const res = await jsSdk.invoke<{ userId?: string }>('getCurExternalContact', {})
    if (!res || !res.userId) return
    let data:any = {wxId:res.userId,userId:value.id}
    const linkdata = await unlinkData(data)
    console.log(linkdata)
    if(linkdata.data==='unlink  OK'){
      let data = listData
      data[index].islink = false
      setListData([...data])
    }
  }
  // const sendMsg = useCallback(async () => {
  //   if (!msg) alert('消息不能为空')

  //   await jsSdk.invoke('sendChatMessage', {
  //     msgtype: 'text',
  //     text: {
  //       content: msg
  //     }
  //   });
  // }, [msg])
  const getUserBase = async () => {
    const res = await jsSdk.invoke<{ userId?: string }>('getCurExternalContact', {})
    console.log(res)
    if (!res || !res.userId) return
    let data:any = {...listQuery}
    data.wxId=res.userId
    const baseItem = await selectUserBase(data)
    console.log(baseItem)
    if(baseItem.data.data)setListData([...baseItem.data.data])
  }
  const inputChange=(e:any)=>{
    let Query = {...listQuery}
    Query.mobileOrUserName=e.target.value
    setListQuery(Query)
  }
  const getInput = (e:any) => {
    if (e.key === 'Enter') {
      getUserBase()
    }
  }
  const back = ()=>{
    history.goBack()
  }

  useEffect(() => {
    //getUserBase()
  }, [])

  return (
    <div>
      {/* <Button type='primary' className='back' onClick={back.bind(this)}>返回</Button> */}
      <div className="flex search">
        <LeftOutlined onClick={back.bind(this)}/><Input className='searchInt' allowClear placeholder="请输入客户信息"  prefix={<SearchOutlined />} onChange={inputChange}  onKeyDown={getInput}/>
        {/* <Button size='small'>取消</Button> */}
        {/* <div className="cancel"><CloseCircleOutlined /></div> */}
      </div>
      <Tabs defaultActiveKey={tabIndex} onChange={callback.bind(this)}>
        {
          tabs.map((item:any,idx:number)=>
          
            <TabPane tab={item} key={idx} >
              <div className="content">
                {listData.length===0? <p className='detailWord'>暂无数据,请输入查询条件</p>:listData.map((list:any,index:number)=>
                  <div className="customItem">
                    <div className="flex spaceBetween w100">
                      <div className="leftItem">
                        <p className='customName'>{list.realName}</p>
                        <p className='customFhone'>{list.mobileNumber}</p>
                        <p className="detailWord">{list.sex===1?'男':'女'}</p>
                        <p className="detailWord">{list.email}</p>
                        <p className="detailWord">身份证</p>
                        <p className="detailWord">{list.idNumber}</p>
                      </div>
                      <div className="rightItem">
                        {list.avatar?<img src={list.avatar} className='avatar' alt="" />:( <div className="avatar"></div> )}
                        <div className="mgt">
                            {list.islink?
                              <Button type="primary" size='small' danger onClick={unlink.bind(this,list,index)}>取消关联</Button>:
                              <Button type="primary" size='small' onClick={link.bind(this,list,index)}>关联客户</Button>
                              }
                        </div>
                      </div>
                    </div>
                  </div>
                  )}
              </div>
              {/* <Table
                columns={columns}
                dataSource={listData}
                scroll={{ x: 300 }}
                bordered
              /> */}
          </TabPane>
        )
        }
      </Tabs>
    </div>
  )
}

export default Actions
